<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::capabilityAgents::settings::Settings Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents.html">capabilityAgents</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1settings.html">settings</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html">Settings</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::capabilityAgents::settings::Settings Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_settings_8h_source.html">Settings.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::capabilityAgents::settings::Settings:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_inherit__map" id="alexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html" title="alexaClientSDK::registration\lManager::CustomerDataHandler" alt="" coords="25,5,239,44"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::CapabilityConfiguration\lInterface" alt="" coords="5,68,259,120"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::capabilityAgents::settings::Settings:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_coll__map" id="alexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html" title="alexaClientSDK::registration\lManager::CustomerDataHandler" alt="" coords="25,5,239,44"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::CapabilityConfiguration\lInterface" alt="" coords="5,68,259,120"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a1f45f5f7f8a37ef81a2d7b689e529ace"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html#a1f45f5f7f8a37ef81a2d7b689e529ace">addSingleSettingObserver</a> (const std::string &amp;key, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_single_setting_observer_interface.html">avsCommon::sdkInterfaces::SingleSettingObserverInterface</a> &gt; settingsObserver)</td></tr>
<tr class="separator:a1f45f5f7f8a37ef81a2d7b689e529ace"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ace993c0b2241b7e8e5f236a2d9ba68c9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html#ace993c0b2241b7e8e5f236a2d9ba68c9">removeSingleSettingObserver</a> (const std::string &amp;key, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_single_setting_observer_interface.html">avsCommon::sdkInterfaces::SingleSettingObserverInterface</a> &gt; settingObserver)</td></tr>
<tr class="separator:ace993c0b2241b7e8e5f236a2d9ba68c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2c88b6003f703d1d3e7e0659a815510f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html#a2c88b6003f703d1d3e7e0659a815510f">addGlobalSettingsObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_global_settings_observer_interface.html">avsCommon::sdkInterfaces::GlobalSettingsObserverInterface</a> &gt; globalSettingsObserver)</td></tr>
<tr class="separator:a2c88b6003f703d1d3e7e0659a815510f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d0e615268ae97d4267ff206cc9b5f6e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html#a7d0e615268ae97d4267ff206cc9b5f6e">removeGlobalSettingsObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_global_settings_observer_interface.html">avsCommon::sdkInterfaces::GlobalSettingsObserverInterface</a> &gt; globalSettingsObserver)</td></tr>
<tr class="separator:a7d0e615268ae97d4267ff206cc9b5f6e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac25a76543c6167dd86a3eef9ff5a814e"><td class="memItemLeft" align="right" valign="top">std::future&lt; bool &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html#ac25a76543c6167dd86a3eef9ff5a814e">changeSetting</a> (const std::string &amp;key, const std::string &amp;value)</td></tr>
<tr class="separator:ac25a76543c6167dd86a3eef9ff5a814e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3dd3b15e274a822427472df4ef75f7ba"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html#a3dd3b15e274a822427472df4ef75f7ba">sendDefaultSettings</a> ()</td></tr>
<tr class="separator:a3dd3b15e274a822427472df4ef75f7ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2eeec99cb9ac3877f708d0e1a2439dc1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html#a2eeec99cb9ac3877f708d0e1a2439dc1">clearData</a> () override</td></tr>
<tr class="separator:a2eeec99cb9ac3877f708d0e1a2439dc1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">CapabilityConfigurationInterface Functions</div></td></tr>
<tr class="memitem:a8a8433e5aeaea219dc515c2753b3a1fe"><td class="memItemLeft" align="right" valign="top">std::unordered_set&lt; std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_configuration.html">avsCommon::avs::CapabilityConfiguration</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html#a8a8433e5aeaea219dc515c2753b3a1fe">getCapabilityConfigurations</a> () override</td></tr>
<tr class="separator:a8a8433e5aeaea219dc515c2753b3a1fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html">alexaClientSDK::registrationManager::CustomerDataHandler</a></td></tr>
<tr class="memitem:a2246fb7b5773b2d9643e880bde58acf9 inherit pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html#a2246fb7b5773b2d9643e880bde58acf9">CustomerDataHandler</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_manager.html">CustomerDataManager</a> &gt; customerDataManager)</td></tr>
<tr class="separator:a2246fb7b5773b2d9643e880bde58acf9 inherit pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a067f8855e7ac0c05fc190b6b2e8e2d19 inherit pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html#a067f8855e7ac0c05fc190b6b2e8e2d19">~CustomerDataHandler</a> ()</td></tr>
<tr class="separator:a067f8855e7ac0c05fc190b6b2e8e2d19 inherit pub_methods_classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::CapabilityConfigurationInterface</a></td></tr>
<tr class="memitem:ac5cec30da8c9039ec5eea44b82f018eb inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html#ac5cec30da8c9039ec5eea44b82f018eb">~CapabilityConfigurationInterface</a> ()=default</td></tr>
<tr class="separator:ac5cec30da8c9039ec5eea44b82f018eb inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a3900feba7964d1301b188f0c2bd03e15"><td class="memItemLeft" align="right" valign="top">static std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html">Settings</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html#a3900feba7964d1301b188f0c2bd03e15">create</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html">SettingsStorageInterface</a> &gt; settingsStorage, std::unordered_set&lt; std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_global_settings_observer_interface.html">avsCommon::sdkInterfaces::GlobalSettingsObserverInterface</a> &gt;&gt; observers, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_manager.html">registrationManager::CustomerDataManager</a> &gt; dataManager)</td></tr>
<tr class="separator:a3900feba7964d1301b188f0c2bd03e15"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">This class implements <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html">Settings</a> Interface to manage Alexa <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html">Settings</a> on the product.</p>
<p class="">This class writes the Setting change to database and notifies the observers of the setting. </p><dl class="section see"><dt>See also</dt><dd><a href="https://developer.amazon.com/public/solutions/alexa/alexa-voice-service/reference/settings">https://developer.amazon.com/public/solutions/alexa/alexa-voice-service/reference/settings</a> </dd></dl>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a2c88b6003f703d1d3e7e0659a815510f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2c88b6003f703d1d3e7e0659a815510f">&#9670;&nbsp;</a></span>addGlobalSettingsObserver()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::settings::Settings::addGlobalSettingsObserver </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_global_settings_observer_interface.html">avsCommon::sdkInterfaces::GlobalSettingsObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>globalSettingsObserver</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Add the observer from the <code>m_globalSettingsObserver</code>. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">settingsGlobalObserver</td><td>The observer to be added to <code>m_globalSettingsObserver</code>. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a1f45f5f7f8a37ef81a2d7b689e529ace"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1f45f5f7f8a37ef81a2d7b689e529ace">&#9670;&nbsp;</a></span>addSingleSettingObserver()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::settings::Settings::addSingleSettingObserver </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_single_setting_observer_interface.html">avsCommon::sdkInterfaces::SingleSettingObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>settingsObserver</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Add an observer for a single setting mapped to the setting key. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The name of the setting to which an observer is mapped to. </td></tr>
    <tr><td class="paramname">settingObserver</td><td>The observer to be added to <code>m_mapOfSettingsAttributes</code>. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ac25a76543c6167dd86a3eef9ff5a814e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac25a76543c6167dd86a3eef9ff5a814e">&#9670;&nbsp;</a></span>changeSetting()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::future&lt; bool &gt; alexaClientSDK::capabilityAgents::settings::Settings::changeSetting </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Function called by the application when a Setting is changed. It calls <code>executeChangeSetting</code> via the executor.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The name of the setting which is changed. </td></tr>
    <tr><td class="paramname">value</td><td>The new value of the setting. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A future which is <code>true</code> if the setting is changed successfully else <code>false</code>. </dd></dl>

</div>
</div>
<a id="a2eeec99cb9ac3877f708d0e1a2439dc1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2eeec99cb9ac3877f708d0e1a2439dc1">&#9670;&nbsp;</a></span>clearData()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::settings::Settings::clearData </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Clears the settings storage and attributes </p>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html#a36e0bb31b4187dbc04141aca7209f4c5">alexaClientSDK::registrationManager::CustomerDataHandler</a>.</p>

</div>
</div>
<a id="a3900feba7964d1301b188f0c2bd03e15"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3900feba7964d1301b188f0c2bd03e15">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html">Settings</a> &gt; alexaClientSDK::capabilityAgents::settings::Settings::create </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html">SettingsStorageInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>settingsStorage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::unordered_set&lt; std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_global_settings_observer_interface.html">avsCommon::sdkInterfaces::GlobalSettingsObserverInterface</a> &gt;&gt;&#160;</td>
          <td class="paramname"><em>observers</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_manager.html">registrationManager::CustomerDataManager</a> &gt;&#160;</td>
          <td class="paramname"><em>dataManager</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Creates a new <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html">Settings</a></code> instance. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">settingsStorage</td><td>An interface to store, load, modify and delete <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html">Settings</a>. </td></tr>
    <tr><td class="paramname">globalSettingsObserver</td><td>A set of SettingsGlobalObserver which are notified when all the settings are changed. </td></tr>
    <tr><td class="paramname">dataManager</td><td>A dataManager object that will track the CustomerDataHandler. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>An instance of <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html">Settings</a> if construction is successful or nullptr if construction fails. </dd></dl>

</div>
</div>
<a id="a8a8433e5aeaea219dc515c2753b3a1fe"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8a8433e5aeaea219dc515c2753b3a1fe">&#9670;&nbsp;</a></span>getCapabilityConfigurations()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unordered_set&lt; std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_configuration.html">avsCommon::avs::CapabilityConfiguration</a> &gt; &gt; alexaClientSDK::capabilityAgents::settings::Settings::getCapabilityConfigurations </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Returns the configurations of the capability interfaces being implemented.</p>
<dl class="section return"><dt>Returns</dt><dd>A set of CapabilityConfigurations </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html#a1d4d5be614325de11563b2375fbb651c">alexaClientSDK::avsCommon::sdkInterfaces::CapabilityConfigurationInterface</a>.</p>

</div>
</div>
<a id="a7d0e615268ae97d4267ff206cc9b5f6e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7d0e615268ae97d4267ff206cc9b5f6e">&#9670;&nbsp;</a></span>removeGlobalSettingsObserver()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::settings::Settings::removeGlobalSettingsObserver </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_global_settings_observer_interface.html">avsCommon::sdkInterfaces::GlobalSettingsObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>globalSettingsObserver</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Remove the observer from the <code>m_globalSettingsObserver</code>. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">settingsGlobalObserver</td><td>The observer to be removed from <code>m_globalSettingsObserver</code>. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ace993c0b2241b7e8e5f236a2d9ba68c9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ace993c0b2241b7e8e5f236a2d9ba68c9">&#9670;&nbsp;</a></span>removeSingleSettingObserver()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::settings::Settings::removeSingleSettingObserver </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_single_setting_observer_interface.html">avsCommon::sdkInterfaces::SingleSettingObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>settingObserver</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Remove the observer for a single setting mapped to the setting key. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The name of the setting to which an observer is mapped to. </td></tr>
    <tr><td class="paramname">settingObserver</td><td>The observer to be removed from <code>m_mapOfSettingsAttributes</code>. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a3dd3b15e274a822427472df4ef75f7ba"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3dd3b15e274a822427472df4ef75f7ba">&#9670;&nbsp;</a></span>sendDefaultSettings()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::settings::Settings::sendDefaultSettings </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Function which sends the default settings to AVS if the settings do not already exist in the database. If the settings already exist, the event is not sent. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/CapabilityAgents/Settings/include/Settings/<a class="el" href="_settings_8h_source.html">Settings.h</a></li>
<li>/workplace/avs-device-sdk/CapabilityAgents/Settings/src/<a class="el" href="_settings_8cpp.html">Settings.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
